<template>
  <div class="table-container">
    <template v-if="showState === 1">
      <!-- <vab-query-form> -->
        <!-- <vab-query-form-left-panel> -->
          <el-form ref="form" :model="queryForm" :inline="true" @submit.native.prevent>
            <el-form-item label="统一编码"><el-input placeholder="请输入" v-model="form.uniformcode" clearable></el-input></el-form-item>
            <el-form-item label="名称"><el-input placeholder="请输入" v-model="form.name" clearable></el-input></el-form-item>
            <el-form-item label="类型">
              <el-select v-model="form.type" placeholder="请选择" clearable>
                <el-option
                  v-for="item in typeOptions"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value">
                </el-option>
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button icon="el-icon-search" type="primary" native-type="submit" @click="fetchData">查询</el-button>
            </el-form-item>
            <el-form-item style="float: right;">
              <el-button icon="el-icon-plus" type="primary" @click="handleAdd">添加</el-button>
              <el-button icon="el-icon-delete" type="danger" @click="handleDelete">删除</el-button>
              <el-button type="primary" @click="generate">生成</el-button>
            </el-form-item>
          </el-form>
        <!-- </vab-query-form-left-panel> -->
        <!-- <vab-query-form-right-panel> -->
          <!-- <UploadExcel style="margin-left: 10px;" @getResult="getMyExcelData"></UploadExcel>
          <ExportExcel :exportList="exportExcel" partsName="公司"></ExportExcel> -->
        <!-- </vab-query-form-right-panel> -->
      <!-- </vab-query-form> -->
      <el-table ref="tableSort" v-loading="listLoading" :data="list" :element-loading-text="elementLoadingText"
        :height="height" @selection-change="setSelectRows">
        <el-table-column show-overflow-tooltip type="selection" width="55"></el-table-column>
        <el-table-column show-overflow-tooltip label="id" prop="id" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="类型" prop="type" align="center" sortable :formatter="dateFormat"></el-table-column>
        <el-table-column show-overflow-tooltip label="测点编码" prop="point" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="统一编码" prop="uniformcode" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="名称" prop="name" align="center" sortable></el-table-column>
        <el-table-column show-overflow-tooltip label="操作" width="240px">
          <template #default="{ row }">
            <el-button type="text" @click="handleEdit(row)">编辑</el-button>
            <el-button type="text" @click="handleDelete(row)">删除</el-button>
            <el-button type="text" @click="generate(row)">生成</el-button>
            <el-button type="text" @click="equipmentAllocation(row)" v-show="row.type === 'fjjs' || row.type === 'fjjc'">设备点表配置</el-button>
            <el-button type="text" @click="stationAllocation(row)" v-show="row.type === 'czjs'">场站点表配置</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination :background="background" :current-page="queryForm.pageNo" :layout="layout"
        :page-size="queryForm.pageSize" :total="total" @current-change="handleCurrentChange"
        @size-change="handleSizeChange"></el-pagination>
      <table-edit ref="edit" :options="options" @save-success="fetchData"></table-edit>
    </template>
    <EquipmentAllocation :showValue="showData" v-if="showState === 2" @cutState="cutState"/>
    <StationAllocation :showValue="showData" v-if="showState === 3" @cutState="cutState"/>
  </div>
</template>
<script>
import EquipmentAllocation from './equipmentAllocation/index'
import StationAllocation from './stationAllocation/index'
// import ExportExcel from '@/components/ExportExcel/index'
// import ExportExcel from '@/components/ExportExcel/index'
import TableEdit from './components/TableEdit'
import api from '@/api/pointConfiguration'
export default {
  components: {
    // UploadExcel,
    // ExportExcel,
    TableEdit,
    EquipmentAllocation,
    StationAllocation
  },
  data() {
    return {
      showState: 1,
      showData: {},
      typeOptions: [
        {value: 'fjjs', label:'风机计算'},
        {value: 'czjs', label:'场站计算'},
        {value: 'fjjc', label:'风机基础点'},
      ],
      form :{
        uniformcode: '',
        name: '',
        type: '',
      },
      // 
      // fuzzyQuery: '',
      listLoading: true,
      list: [],
      options: [],
      exportExcel: [],
      elementLoadingText: '正在加载...',
      selectRows: '',
      layout: 'total, sizes, prev, pager, next, jumper',
      total: 0,
      background: true,
      exportList: [],
      queryForm: {
        pageNo: 1,
        pageSize: 20,
      },
    };
  },
  created() {
    this.fetchData()
  },
  computed: {
    height() {
      return this.$baseTableHeight() + 50
    },
  },
  methods: {
    dateFormat(row, column, cellValue, index) {
      for (const iterator of this.typeOptions) {
        if(row.type === iterator.value){
          return iterator.label
        }
      }
    },
    cutState(data){
      this.showState = data
    },
    equipmentAllocation(data){
      this.showState = 2
      this.showData = data
    },
    stationAllocation(data){
      this.showState = 3
      this.showData = data
    },
    getMyExcelData(val) {
      val.forEach(item => {
        api.addCompanys(item).then(res => {
          if (res.code == 200) {
            this.$message({
              type: 'success',
              message: '添加成功!'
            });
            this.fetchData()
          }
        })
      })

    },
    fetchData() {
      this.listLoading = true
      api.standardpointList({
        id: '',
        uniformcode: this.form.uniformcode,
        name: this.form.name,
        type: this.form.type,
        pageNum: this.queryForm.pageNo,
        pageSize: this.queryForm.pageSize,
      }).then(res => {
        if (res.data) {
          this.listLoading = false
          this.total = res.data.total
          this.list = res.data.records
          let exportExcel = []
          res.data.records.forEach(item => {
            exportExcel.push({
              id: item.id,
              name: item.name,
              rid: item.rid,
            })
          })
          this.exportExcel = exportExcel
        }
      })
    },
    handleSizeChange(val) {
      this.queryForm.pageSize = val
      this.fetchData()
    },
    handleCurrentChange(val) {
      this.queryForm.pageNo = val
      this.fetchData()
    },
    handleAdd() {
      this.$refs['edit'].showEdit()
    },
    handleEdit(row) {
      this.$refs['edit'].showEdit(row)
    },
    generate(row) {
      if (row.uniformcode || this.selectRows.length > 0) {
        this.$baseConfirm('你确定要生成吗', null, async () => {
          let uniformcodeArr = []
          if (this.selectRows.length > 0) {
            this.selectRows.forEach(element => {
              uniformcodeArr.push(element.uniformcode)
            });
          }
          api.generateAdd({points: [row.uniformcode] || uniformcodeArr}).then(res => {
            if (res.data) {
              this.$baseMessage('生成成功', 'success')
              this.fetchData()
            }
          })
        })
      } else {
        this.$baseMessage('未选中任何行', 'error')
        return false
      }
    },
    handleDelete(row) {
      if (row.id || this.selectRows.length > 0) {
        this.$baseConfirm('你确定要删除吗', null, async () => {
          let ids = ''
          if (this.selectRows.length > 0) {
            ids = this.selectRows.map((item) => item.id).join()
          }
          api.deleteStandardpoint({
            id: row.id || ids
          }).then(res => {
            if (res.data) {
              this.$baseMessage('删除成功', 'success')
              this.fetchData()
            }
          })
        })
      } else {
        this.$baseMessage('未选中任何行', 'error')
        return false
      }
    },
    setSelectRows(val) {
      this.selectRows = val
    },
  },
}
</script>
<style lang="less" scoped>
 a{
  float: right;
 }
</style>